//
//  UIApplication+Additions.m
//  That's What She Said
//
//  Created by Matthew on 1/21/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "UIApplication+Additions.h"


@implementation UIApplication (Macfanatic)


- (NSString*)documentsPath {
	NSArray* paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES);
	return [paths objectAtIndex:0];
}


- (void)openTwitterAppForFollowingUser:(NSString *)twitterUserName {
	
	// Tweetie: http://developer.atebits.com/tweetie-iphone/protocol-reference/
	NSURL *tweetieURL = [NSURL URLWithString:[NSString stringWithFormat:@"tweetie://user?screen_name=%@", twitterUserName]];
	if ([self canOpenURL:tweetieURL]) {
		[self openURL:tweetieURL];
		return;
	}
	
	// Birdfeed: http://birdfeed.tumblr.com/post/172994970/url-scheme
	NSURL *birdfeedURL = [NSURL URLWithString:[NSString stringWithFormat:@"x-birdfeed://user?screen_name=%@", twitterUserName]];
	if ([self canOpenURL:birdfeedURL]) {
		[self openURL:birdfeedURL];
		return;
	}
	
	// Twittelator: http://www.stone.com/Twittelator/Twittelator_API.html
	NSURL *twittelatorURL = [NSURL URLWithString:[NSString stringWithFormat:@"twit:///user?screen_name=%@", twitterUserName]];
	if ([self canOpenURL:twittelatorURL]) {
		[self openURL:twittelatorURL];
		return;
	}
	
	// Icebird: http://icebirdapp.com/developerdocumentation/
	NSURL *icebirdURL = [NSURL URLWithString:[NSString stringWithFormat:@"icebird://user?screen_name=%@", twitterUserName]];
	if ([self canOpenURL:icebirdURL]) {
		[self openURL:icebirdURL];
		return;
	}
	
	// Fluttr: no docs
	NSURL *fluttrURL = [NSURL URLWithString:[NSString stringWithFormat:@"fluttr://user/%@", twitterUserName]];
	if ([self canOpenURL:fluttrURL]) {
		[self openURL:fluttrURL];
		return;
	}
	
	// SimplyTweet: http://motionobj.com/blog/url-schemes-in-simplytweet-23
	NSURL *simplytweetURL = [NSURL URLWithString:[NSString stringWithFormat:@"simplytweet:?link=http://twitter.com/%@", twitterUserName]];
	if ([self canOpenURL:simplytweetURL]) {
		[self openURL:simplytweetURL];
		return;
	}
	
	// Tweetings: http://tweetings.net/iphone/scheme.html
	NSURL *tweetingsURL = [NSURL URLWithString:[NSString stringWithFormat:@"tweetings:///user?screen_name=%@", twitterUserName]];
	if ([self canOpenURL:tweetingsURL]) {
		[self openURL:tweetingsURL];
		return;
	}
	
	/* --- disabled until Echofon fixes the crash when using this
	 // Echofon: http://echofon.com/twitter/iphone/guide.html
	 NSURL *echofonURL = [NSURL URLWithString:[NSString stringWithFormat:@"echofon:///user_timeline?%@", twitterUserName]];
	 if ([self canOpenURL:echofonURL]) {
		[self openURL:echofonURL];
		return;
	 }
	 */
	
	// --- Fallback: Mobile Twitter in Safari
	NSURL *safariURL = [NSURL URLWithString:[NSString stringWithFormat:@"http://mobile.twitter.com/%@", twitterUserName]];
	[self openURL:safariURL];
}

@end
