//
//  NSApplication+Analytics.m
//  macfanatic
//
//  Created by Matthew Brewer on 2/28/11.
//  Copyright 2011 University of Tennessee: College of Business. All rights reserved.
//

#import "UIApplication+Analytics.h"

NSString* const kGoogleAnalyticsKey = @"Google Analytics";

@implementation UIApplication (Analytics)

- (void)startTracking {
	NSString* key = [[[NSBundle mainBundle] infoDictionary] objectForKey:kGoogleAnalyticsKey];
	NSLog(@"Analytic Tracker started with account \"%@\"", key);
	[[GANTracker sharedTracker] startTrackerWithAccountID:key dispatchPeriod:10 delegate:self];
}

- (void)trackLaunch {
	[[GANTracker sharedTracker] trackPageview:@"/launch" withError:nil];
}

- (void)stopTracking {
	[[GANTracker sharedTracker] stopTracker];
}

- (void)trackerDispatchDidComplete:(GANTracker *)tracker eventsDispatched:(NSUInteger)eventsDispatched eventsFailedDispatch:(NSUInteger)eventsFailedDispatch {
	NSLog(@"Analytic Tracker (%d of %d failed)", eventsFailedDispatch, eventsDispatched);
}

@end
